<?php
/*
 * Created on 6 Aug 2007 
 * By julien reichel <julien.reichel@spinetix.com>
 */
$title="RS232 / USB IO"; 
include ("prolog.php");
 
 
$BaudRatesSet= array( 110, 300, 600, 1200, 2400, 4800, 9600, 14400, 19200, 38400, 57600, 115200, 128000, 256000 );
$paritySet=array("none", "even", "odd");
$flowControlSet=array("none", "XonXoff", "RTS/CTS", "RS485");
$byteSizeSet=array("7", "8");
$stopBitsSet=array("0", "1");

$doShutdown=false;

$config_name="/etc/raperca/spxconfig.xml";

$comport = new ComPort;
$config = new DOMDocument;
$config->loadXML(file_get_contents($config_name));
$comport->load( $config );

if ( isset($_POST['upload']))
	$comport->addFile( "new_file" );
	

if ( isset($_POST['update'])) {
	if ( $comport->set( $_POST ) ){
		$comport->save( $config );
		save_file($config_name,$config->saveXML());
		$doShutdown=true;
	}
}

$filelist = $comport->getFileList();

if ($doShutdown){
	shutdown("serial port config change");
} else {
$disableCOMFields="";

if ($comport->href=="[disabled]")	$disableCOMFields="disabled='disabled' ";
?>
<script type="text/javascript">
<!--
function enableCOMPortSettings()
{
	var selectFile=document.getElementById("COMPortFileSelect");
	var enablePower=document.getElementById("ControlMonPower");
	var enablePower2=document.getElementById("ControlMonPower2");
	var enableSettings=document.getElementById("ControlCOMPortSettings");

	enablePower.disabled=(selectFile.selectedIndex==0 );
	enablePower2.disabled=(selectFile.selectedIndex==0 );
	document.getElementsByName("onTime")[0].disabled=(selectFile.selectedIndex==0 || !enablePower.checked);
	document.getElementsByName("offTime")[0].disabled=(selectFile.selectedIndex==0 || !enablePower.checked);
	
	enableSettings.disabled=(selectFile.selectedIndex==0 );
	document.getElementsByName("baudRate")[0].disabled=(selectFile.selectedIndex==0 || !enableSettings.checked);
	document.getElementsByName("byteSize")[0].disabled=(selectFile.selectedIndex==0 || !enableSettings.checked);
	document.getElementsByName("parity")[0].disabled=(selectFile.selectedIndex==0 || !enableSettings.checked);
	document.getElementsByName("stopBits")[0].disabled=(selectFile.selectedIndex==0 || !enableSettings.checked);
	
}

-->
</script>
<h2>Settings: </h2>
<form action="comport.php" method="post" >
<table>
  <tr><td colspan="2" >Protocols : </td><td colspan="2">
<?php
print "<select id='COMPortFileSelect' name='href' onchange='enableCOMPortSettings()'>";
foreach ($filelist as $name => $val) {
	echo "<option value=\"", htmlspecialchars($val), "\""; 
	if ($confpath.$val==$comport->href) echo " selected='selected'";
	echo ">", htmlspecialchars($name), "</option>\n";	
}
print "</select></td></tr>\n"; 

print "<tr><td >\n";
print "<input type='hidden' $disableCOMFields name='monPower' value='false' id='ControlMonPower2'/>";
print "<input type='checkbox' $disableCOMFields id='ControlMonPower' value='true' onclick='enableCOMPortSettings()' name='monPower' ";
if ( $comport->monPower=="true" ){
	 print "checked='checked' />";
	 $enableMonPower=$disableCOMFields;
}else{
	print "/>";
	$enableMonPower="disabled='disabled' ";
}
print "</td><td>Use fixed schedule for display power</td></tr >\n"; 
print "<tr><td/><td>Turn monitor ON</td><td><input size='8' type='text' name='onTime' value=\"". htmlspecialchars($comport->onTime) ."\" $enableMonPower/></td></tr>\n";
print "<tr><td/><td>Turn monitor OFF</td><td><input size='8' type='text' name='offTime' value=\"". htmlspecialchars($comport->offTime). "\" $enableMonPower/></td></tr>\n";

print "<tr><td >\n";
print "<input type='hidden' name='comSettings' value='false' />";
print "<input type='checkbox' $disableCOMFields id='ControlCOMPortSettings' value='true' onclick='enableCOMPortSettings()' name='comSettings' ";
if ( $comport->comSettings=="true" ){
	print "checked='checked' />";
	$enableCOMSettings=$disableCOMFields;
}else{
	print "/>";
	$enableCOMSettings="disabled='disabled' ";
}
print "</td><td>Modify COM port settings</td></tr >\n"; 

print "<tr><td/><td >Baud rate : </td><td ><select name='baudRate' $enableCOMSettings>\n";
foreach ($BaudRatesSet as $val) {
     echo "<option value=\"", htmlspecialchars($val), "\""; 
	if ($val==$comport->baudRate) echo " selected='selected'";
	echo ">", htmlspecialchars($val), "</option>\n";	
}
print "</select></td></tr>\n";
print "<tr><td/><td >Data bits : </td><td ><select name='byteSize' $enableCOMSettings>\n";
foreach ($byteSizeSet as $val) {
     echo "<option value=\"", htmlspecialchars($val), "\""; 
 	if ($val==$comport->byteSize) echo " selected='selected'";
	echo ">", htmlspecialchars($val), "</option>\n";	
}
print "</select></td></tr>\n";
print "<tr><td/><td >Parity : </td><td ><select name='parity' $enableCOMSettings>\n";
foreach ($paritySet as $val) {
 	echo "<option value=\"", htmlspecialchars($val), "\""; 
 	if ($val==$comport->parity) echo " selected='selected'";
	echo ">", htmlspecialchars($val), "</option>\n";	
}
print "</select></td></tr>\n";
print "<tr><td/><td >Stop bits : </td><td ><select name='stopBits' $enableCOMSettings>\n";
foreach ($stopBitsSet as $val) {
     echo "<option value=\"", htmlspecialchars($val), "\""; 
 	if ($val==$comport->stopBits) echo " selected='selected'";
	echo ">", htmlspecialchars($val), "</option>\n";	
}
print "</select></td></tr>\n";

print "<input type='hidden' name='powerSave' value='".$comport->powerSave."' />\n";
?>
</table>

<input type="submit" value="Apply" name="update"/>
</form>
<br/>
<h2>Upload Protocol File: </h2>
<br/>
<form action="comport.php" method="post" enctype="multipart/form-data">
<input size='40' type='file' name='new_file' /><br/>
<br/>
<input type="submit" value="Upload" name="upload"/>
</form>

<?php
} // not shutting down
include ("final.php");
?>